#ifndef ENGINE_HPP
#define ENGINE_HPP

#include <vector>
#include <iostream>
using namespace std;

#include "subengines.hpp"
#include "enginepart.hpp"

/*
notes:
  would be better to attach init to engine_state
*/

class Engine: public SubengineInterface {
public:
  void run();
  Engine();
  virtual ~Engine();
protected:
  int partindex;
  virtual int control(int oldpart, int message)=0;
  vector<EnginePart*> section;
};

#endif /* ENGINE_HPP */
