#include "math.hpp"

float distfromlinesq(float x1,float y1,float x2,float y2,float x,float y)
{
	float A = x - x1;
	float B = y - y1;
	float C = x2 - x1;
	float D = y2 - y1;

	float dot = A * C + B * D;
	float len_sq = C * C + D * D;
	float param = dot / len_sq;

	float xx,yy;

	if(param < 0)
	{
		xx = x1;
		yy = y1;
	}
	else if(param > 1)
	{
		xx = x2;
		yy = y2;
	}
	else
	{
		xx = x1 + param * C;
		yy = y1 + param * D;
	}

	return (yy-y)*(yy-y)+(xx-x)*(xx-x);//your distance function
}
